#ifndef RKR4SKetlle_H
#define RKR4SKetlle_H

#include "R4S.h"
#include "r4scfg.h"

class R4SKetlleStatus {
  public:
    R4SKetlleStatus(uint8_t* data = 0);
    R4SKetlleStatus(const R4SKetlleStatus& other);
    R4SKetlleStatus& operator =(const R4SKetlleStatus& other);

    bool isValid();

    uint8_t program;
    uint8_t state;
    uint8_t error;
    bool isHeating;
    uint8_t remainingHours;
    uint8_t remainingMinutes;
    uint8_t targetTemperature;
    uint8_t currentTemperature;

  private:
    void copyFrom(const R4SKetlleStatus& other);

    bool m_valid;
};

bool r4SKetlleOff();
bool r4SKetlleOn(uint8_t boil, uint8_t temp);
bool r4SKetlleBoil();
bool r4SKetlleHeat(uint8_t temp);
bool r4SKetlleBoilAndHeat(uint8_t temp);
#ifdef R4S_NIGHT_LIGHT
bool r4SKetlle_NLOn();
bool r4SKetlle_NLsettings();
#endif
R4SKetlleStatus r4SKetlleStatus();

String getStatusJson(BLEAddress* addr);

#endif
